--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
-------o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o-------
--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

local HasFullControl = HasFullControl
local GetSpellInfo = GetSpellInfo
local GetTotemInfo = GetTotemInfo
local GetTotemTimeLeft = GetTotemTimeLeft

local hasFE, bloodLust, ttTotem, lbAlready = false, false, false, false
local refreshTotem = 0

local feName = GetSpellInfo(2894) -- Fire Elemental Totem

if wdwMod_Info == nil then wdwMod_Info = {} end 
if wdwMod_Rotations == nil then wdwMod_Rotations = {} end

local function AddToQueue(spellItemID, direction, expires, pos)

	-- Will insert a spell/item at the first available location, starting from the left-most position consistent with any remaining CD/expiry

	-- spellItemID	:		the spell/item to queue
	-- direction	:		Direction to look for space in the queue. Optional. +1 is the default. -1 will cause a seek leftwards
	-- expires	:		the remaining CD or time to expiry (optional). If nil then calculates

	-- return codes:	0  = no space
	--			n  = queue location

	direction = direction or 1
	if direction ~= 1 then direction = -1 end

	if pos == 0 then return 0 end

	if not pos then
		local cdLeft = expires or WeDontWipe:CooldownLeft(spellItemID)
		pos = math.floor(( cdLeft - wdw_GCD) / wdw_GCDtop) + 1
		if pos < 1 then pos = 1 end
		if pos > wdw_maxQueueLength then return 0 end
	end

	while wdw_Queue[pos] ~= 0 do
		pos = pos + direction
		if pos > wdw_maxQueueLength then return 0 end
		if pos == 0 then return 0 end
	end

	wdw_Queue[pos] = spellItemID
	return pos
end

--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--
-------o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o-------
--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

wdwMod_Info["Taraezor@Thaurissan ElementalShaman"] = {

	["Class"] = "Shaman",
	["Specialisation"] = "Elemental",
	["Version"] = "1.01 for Patch 5.4",
	["Author"] = "Taraezor@Thaurissan",
	["Template"] = "1.00",
--	["Sound"] = "Sound/Doodad/Fx_Owl05.ogg", -- Owl sfx. Quiet and inoffensive
--	["Sound"] = "Sound/Doodad/G_Gongtroll01.Ogg", -- Now that is loud!
	["Sound"] = "Sound/Spells/Shaysbell.ogg",

	["Interrupt"] =	{ 57994,16,},			-- Wind Shear. Off the GCD btw 
	["Purge"] =	{ 370,12,"Magic",},		-- Purge 
	["Cleanse"] =	{ 51886,18,"Curse",},		-- Cleanse Spirit

	["Cooldown"] = {2894,66,2062,58,114049,87,108285,45,108271,15,108270,15,108280,75,108281,75,2825,70,120668,78,556,34,16188,60}, -- spellID,level,...
	-- Fire Elemental Totem, Earth Elemental Totem, Ascendance, Call of the Elements, Astral Shift, Stone Bulwark Totem, Healing Tide Totem,
	-- Ancestral Guidance, Bloodlust, Stormlash Totem, Astral Recall, Ancestral Swiftness
}

wdwMod_Rotations["Taraezor@Thaurissan ElementalShaman"] = {

	["Rotations"] = {
		["Single"] = {
			["Buffs"] = {"Weapon","LS",},
			["Rotation"] = {"Setup","TT","FSUE","EMAS","LB","Tier6","ES","FireTotem","BL","Swift","Filler",},
			["Notes"] = ""
		},

	},

	["Weapon"] = function () -- Flametongue MH. Level 10, but allow for others etc

		-- Rockbiter, Level 75, is useless / for novelty value only, even if trying desperately to "off tank" in a pinch
		-- Frostbrand Attack, Level 26, might have some questing use as it does slow mobs = kiting. Allow this

		if wdw_usingFishingPole then return end

		if wdw_buffsPlayer["MainHand"] then
			if WeDontWipe:HasCanShow(8024) then -- Flametongue Weapon
				AddToQueue(8024,1,wdw_buffsPlayer["MainHand"].expires)
			elseif WeDontWipe:HasCanShow(8232) then -- Windfury Weapon
				AddToQueue(8232,1,wdw_buffsPlayer["MainHand"].expires)
			elseif WeDontWipe:HasCanShow(8033) then -- Frostbrand Weapon
				AddToQueue(8033,1,wdw_buffsPlayer["MainHand"].expires)
			elseif WeDontWipe:HasCanShow(8017) then -- Rockbiter Weapon
				AddToQueue(8017,1,wdw_buffsPlayer["MainHand"].expires)
			end
		else
			if WeDontWipe:HasCanShow(8024) then -- Flametongue Weapon
				AddToQueue(8024,1,0)
			elseif WeDontWipe:HasCanShow(8232) then -- Windfury Weapon
				AddToQueue(8232,1,0)
			elseif WeDontWipe:HasCanShow(8033) then -- Frostbrand Weapon
				AddToQueue(8033,1,0)
			elseif WeDontWipe:HasCanShow(8017) then -- Rockbiter Weapon
				AddToQueue(8017,1,0)
			end
		end
	end,

	["LS"] = function () -- Lightning Shield. Level 8

		if WeDontWipe:HasCanShow(324) then -- Lightning Shield
			if wdw_buffsPlayer["324"] then
				AddToQueue(324,1,wdw_buffsPlayer["324"].expires)
			else
				AddToQueue(324)
			end
		end
	end,

	["Setup"] = function ()

		hasFE, bloodLust, ttTotem, lbAlready = false, false, false, false
		refreshTotem = 0

		if wdw_buffsPlayer["2825"] or wdw_buffsPlayer["32182"] or wdw_buffsPlayer["80353"] or wdw_buffsPlayer["90355"] then
				-- Bloodlust (H), Heroism (A), Timewarp, Ancient Hysteria
			bloodLust = true
		end

		if wdw_buffsPlayer["77657"] then -- 77657 is the Searing Flames buff shamans get from FE or ST
			refreshTotem = wdw_buffsPlayer["77657"].expires
		end
		local _, totemName = GetTotemInfo(1)
		if totemName ~= "" then
			local totemExpires = GetTotemTimeLeft(1)
			if totemExpires > refreshTotem then refreshTotem = totemExpires end
			if totemName == feName then
				hasFE = true
			end
		end
	end,

	["TT"] = function () -- Tremor Totem. Level 54
 
		if not HasFullControl() then
			if WeDontWipe:HasCanShow(8143) then
				if AddToQueue(8143) > 0 then ttTotem = true end
			end
		end
	end,

	["FSUE"] = function () -- Flame Shock. Level 12 with Unleash Elements (sometimes). Level 81

		-- The pro player trick is included here: Unleash Elements gives an Unleash Flame (73683) buff. This causes the next FIRE
		-- spell to geta damage boost. It is possible to cast Lava Burst and then to immediately cast Flame Shock so that they
		-- both land at the same time and BOTH get the damage bonus.
		-- I believe that if Lava Burst is instant due to Lava Surge (77762) then the above trick does not work

		if WeDontWipe:HasCanShow(8050) then -- Flame Shock

			local posFS = 0
			if wdw_debuffsTarget["8050"] then -- FS
				posFS = AddToQueue(8050,1,wdw_debuffsTarget["8050"].expires)
			else
				posFS = AddToQueue(8050)
			end

			if WeDontWipe:HasCanShow(73680) and WeDontWipe:HasCanShow(51505) and -- Unleash Elements & Lava Burst
					not wdw_buffsPlayer["77762"] then 
				if posFS > 0 then
					local posUE = math.floor(( WeDontWipe:CooldownLeft(73680) - wdw_GCD) / wdw_GCDtop) + 1
					if posUE < 0 then posUE = 0 end
					local posLB = math.floor(( WeDontWipe:CooldownLeft(51505) - wdw_GCD) / wdw_GCDtop) + 1
					if posLB < 0 then posLB = 0 end
					if (posUE <= posLB) and (posLB <= posFS) and (posFS >= 3) then

						-- The elements align!!! In the following order: UE, LB, FS

						if wdw_Queue[posFS-1] == 0 then
							wdw_Queue[posFS-1] = 51505 -- LB 2nd
							local earliest =  posFS - 5

							-- Yes LB has a 2 sec cast time, meaning that at worst this logic means that
							-- the FS just misses out on the UF bonus. BUT, haste means that LB will be
							-- less than 2 secs cast. Good players will enjoy the UF on the FS!

							if earliest < 1 then earliest = 1 end
							posUE = 0
							for i = (posFS-2),earliest,-1 do
								if wdw_Queue[i] == 0 then
									posUE = i
									break
								end
							end
							if posUE == 0 then -- give up. we failed
								wdw_Queue[posFS-1] = 0
							else
								wdw_Queue[posUE] = 73680 -- UE 1st
								lbAlready = true
							end
						end
					end
				end
			end
		end
	end,

	["EMAS"] = function () -- Elemental Mastery. Tier 4 talent. Level 60 & Ascendance. Level 87
 
		-- Elemental Mastery and Ascendance should be used together and best not used if Flame Shock will need refreshing

		local hasEM = false
		if wdw_hasTalent["10"] then -- Elemental Mastery
			hasEM = WeDontWipe:HasCanShow(16166)
		end
		local hasAS = WeDontWipe:HasCanShow(114049)
		local newEM, newAS, refreshFS = 0, 0, 0
		if wdw_debuffsTarget["8050"]  then
			refreshFS = wdw_debuffsTarget["8050"].expires
		end

		if hasAS and hasEM and not wdw_buffsPlayer["114050"] then -- AS,EM,AS buff (Ele. version)

			newAS = WeDontWipe:CooldownLeft(114049)
			if refreshFS > (newAS + 15) then -- AS lasts 15 secs
				newEM = WeDontWipe:CooldownLeft(16166)
				if refreshFS > (newEM + 20) then -- EM lasts 20 secs

					if newEM > newAS then
						AddToQueue(16166,1,newEM)
						AddToQueue(114049,1,newEM)
					else
						AddToQueue(16166,1,newAS)
						AddToQueue(114049,1,newAS)
					end
				end
			end
		elseif hasEM then
			newEM = WeDontWipe:CooldownLeft(16166)
			if refreshFS > (newEM + 20) then -- EM lasts 20 secs
				AddToQueue(16166,1,newEM)
			end
		elseif hasAS and not wdw_buffsPlayer["114050"] then 
			newAS = WeDontWipe:CooldownLeft(114049)
			if refreshFS > (newAS + 15) then -- AS lasts 15 secs
				AddToQueue(114049,1,newEM)
			end
		end
	end,

	["LB"] = function () -- Lava Burst. Level 34
 
		if WeDontWipe:HasCanShow(51505) then
			if wdw_buffsPlayer["114050"] then -- Ascendance is up. LB has a zero CD. Spam it to the hilt
				local maxLB = math.floor(( wdw_buffsPlayer["114050"].expires - wdw_GCD) / wdw_GCDtop) + 1
				if maxLB > 0 then
					for i = 1, maxLB do
						if wdw_Queue[i] == 0 then wdw_Queue[i] = 51505 end
					end
				end
			elseif not lbAlready then
				AddToQueue(51505)
			end
		end
	end,

	["Tier6"] = function () -- Unleashed Fury / Elemental Blast. Tier 6 talents. Level 90

		-- As of Patch 5.3 Unleashed Fury is really bad for an Elemental Shammy to use
		-- Talent 17 is Prime Elementalist and it is passive. As with Enhancement Shammies, it is very good.

		if wdw_hasTalent["18"] then -- EB
			if WeDontWipe:HasCanShow(117014) then AddToQueue(117014) end -- Elemental Blast
	--	elseif wdw_hasTalent["16"] then -- UF
	--		if WeDontWipe:HasCanShow(73680) then AddToQueue(73680) end -- Unleash Elements @ Level 81
		end
	end,

	["ES"] = function () -- Earth Shock. Level 6

		if WeDontWipe:HasCanShow(8042) and wdw_charges >= 6 then
			AddToQueue(8042)
		end
	end,

	["FireTotem"] = function () -- Fire Totem. Searing Totem - Level 16, Fire Elemental - Level 66
 
		-- Now that FE is useful in 5.3, the logic is more complicated than just refreshing the ST

		if bloodLust or (wdw_hasTalent["17"]) then -- Prime Elementalist. Tier 6, Level 90 - massive boost to the Fire Elemental
			if hasFE then
				if WeDontWipe:HasCanShow(3599) then -- Searing Totem
					AddToQueue(3599,-1,refreshTotem)
				end
			elseif WeDontWipe:HasCanShow(2894) then -- Fire Elemental
				local posFE = AddToQueue(2894)
				if posFE ~= 1 then
					if WeDontWipe:HasCanShow(3599) then
						AddToQueue(3599,-1,refreshTotem)
					end
				end
			elseif WeDontWipe:HasCanShow(3599) then -- Searing Totem
				AddToQueue(3599)
			end
		elseif WeDontWipe:HasCanShow(3599) then
			pos = AddToQueue(3599,-1,refreshTotem)
			if pos == 0 then
				AddToQueue(3599,1,refreshTotem)
			end
		end
	end,

	["BL"] = function () -- Bloodlust situations

		if bloodLust then
			if WeDontWipe:HasCanShow(120668) then AddToQueue(120668) end -- Stormlash Totem
			if WeDontWipe:HasCanShow(2062) and not ttTotem then -- Earth Elemental Totem. Level 58
				local _, totemName = GetTotemInfo(2)
				if totemName == "" then
					AddToQueue(2062)
				end
			end
		end
	end,

	["Swift"] = function () -- Ancestral Swiftness. Level 60

		if WeDontWipe:HasCanShow(16188) and not wdw_buffsPlayer["114050"] then -- Ancestral Swiftness. Don't waste if have AS up
			AddToQueue(16188)
		end
	end,

	["Filler"] = function () -- Filler

		for i=1,wdw_maxQueueLength do
			if wdw_Queue[i] == 0 then wdw_Queue[i] = 403 end -- Lightning Bolt
		end
	end,
}